Name:       csmock
Version:    1.2.3
Release:    1%{?dist}
Summary:    A mock wrapper for Static Analysis tools

Group:      Development/Tools
License:    GPLv3+
URL:        https://git.fedorahosted.org/cgit/csmock.git
Source0:    https://git.fedorahosted.org/cgit/csmock.git/snapshot/%{name}-%{version}.tar.xz

BuildRequires: help2man
BuildRequires: python
%if !(0%{?fedora} >= 19 || 0%{?rhel} >= 7)
BuildRequires: python-argparse
%endif

Requires: csdiff
Requires: cswrap
Requires: mock
Requires: rpm-build

# TODO: make these sub-packages optional
Requires: csmock-plugin-clang
Requires: csmock-plugin-cppcheck

Obsoletes: csmock-ng <= 1.1.1

BuildArch: noarch

%description
This package contains cov-mockbuild and cov-diffbuild tools that allow to scan
SRPMs by Static Analysis tools in a fully automated way.

%package -n csmock-plugin-clang
Summary: csmock plug-in providing the support for Clang
Requires: csmock

%description -n csmock-plugin-clang
Hihgly experimental, currently suitable only for development of csmock itself.

%package -n csmock-plugin-cppcheck
Summary: csmock plug-in providing the support for Cppcheck
Requires: cscppc
Requires: csmock

%description -n csmock-plugin-cppcheck
Hihgly experimental, currently suitable only for development of csmock itself.

%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%prep
%setup -q

%build
mkdir -p bin man

# ebmed VERSION and PLUGIN_DIR version into the scripts
install -p -m0755 cov-{diff,mock}build bin/
sed -e 's/rpm -qf .SELF/echo %{version}/' -i bin/cov-{diff,mock}build
sed -e 's/@VERSION@/%{name}-%{version}-%{release}/' \
    -e 's|@PLUGIN_DIR@|%{python_sitearch}/csmock/plugins|' \
    -i py/csmock

help2man --no-info --section 1 --name \
    "run static analysis of the given SRPM using mock" \
    bin/cov-mockbuild > man/cov-mockbuild.1

help2man --no-info --section 1 --name \
    "run static analysis of the given the patches in the given SRPM using cov-mockbuild" \
    bin/cov-diffbuild > man/cov-diffbuild.1

help2man --no-info --section 1 --name \
    "run static analysis of the given SRPM using mock" \
    py/csmock > man/csmock.1

%install
install -m0755 -d \
    "$RPM_BUILD_ROOT%{_bindir}" \
    "$RPM_BUILD_ROOT%{_mandir}/man1" \
    "$RPM_BUILD_ROOT%{_datadir}/csmock" \
    "$RPM_BUILD_ROOT%{_datadir}/csmock/scripts" \
    "$RPM_BUILD_ROOT%{python_sitearch}/" \
    "$RPM_BUILD_ROOT%{python_sitearch}/csmock" \
    "$RPM_BUILD_ROOT%{python_sitearch}/csmock/plugins"

install -p -m0755 \
    cov-{diff,mock}build cov-dump-err rpmbuild-rawbuild py/csmock \
    "$RPM_BUILD_ROOT%{_bindir}"

install -p -m0644 man/{csmock,cov-{diff,mock}build}.1 "$RPM_BUILD_ROOT%{_mandir}/man1/"

install -p -m0644 cov_checker_map.txt "$RPM_BUILD_ROOT%{_datadir}/csmock/cwe-map.csv"

install -p -m0644 py/plugins/*.py \
    "$RPM_BUILD_ROOT%{python_sitearch}/csmock/plugins"

install -p -m0755 scripts/*.sh \
    "$RPM_BUILD_ROOT%{_datadir}/csmock/scripts"

%files
%{_bindir}/cov-dump-err
%{_bindir}/cov-diffbuild
%{_bindir}/cov-mockbuild
%{_bindir}/csmock
%{_bindir}/rpmbuild-rawbuild
%{_mandir}/man1/cov-diffbuild.1*
%{_mandir}/man1/cov-mockbuild.1*
%{_mandir}/man1/csmock.1*
%{_datadir}/csmock/cwe-map.csv
%{_datadir}/csmock/scripts/patch-rawbuild.sh
%{python_sitearch}/csmock/plugins/gcc.py*
%doc COPYING

%files -n csmock-plugin-clang
%{_datadir}/csmock/scripts/fixups-clang.sh
%{python_sitearch}/csmock/plugins/clang.py*

%files -n csmock-plugin-cppcheck
%{python_sitearch}/csmock/plugins/cppcheck.py*

%changelog
* Thu Jul 17 2014 Kamil Dudka <kdudka@redhat.com> 1.2.3-1
- update to latest upstream

* Fri Jul 04 2014 Kamil Dudka <kdudka@redhat.com> 1.0.11-1
- update to latest upstream bugfix release

* Thu Jun 19 2014 Kamil Dudka <kdudka@redhat.com> 1.0.10-1
- update to latest upstream bugfix release

* Wed Apr 16 2014 Kamil Dudka <kdudka@redhat.com> 1.0.7-1
- update to latest upstream

* Tue Feb 25 2014 Kamil Dudka <kdudka@redhat.com> 1.0.3-2
- further spec file improvements per Fedora Review Request (#1066029)

* Mon Feb 24 2014 Kamil Dudka <kdudka@redhat.com> 1.0.3-1
- update to new upstream release
- abandon RHEL-5 compatibility per Fedora Review Request (#1066029)

* Wed Feb 19 2014 Kamil Dudka <kdudka@redhat.com> 1.0.2-1
- packaged for Fedora
